// Copyright (C) 2003 by ASUSTeK. All rights are reserved.

//////////////////////////////////////////////
// The System Components

var snsridHasFRU =             parent.asID['DUMMY_SENSORID_HASFRU'];
var snsridHasDMI =             parent.asID['DUMMY_SENSORID_HASDMI'];
var snsridHasIPMI =            parent.asID['DUMMY_SENSORID_HASIPMI'];

var snridMBTemperature1 =       (parent.asID['ASWM_SNRTYPE_TEMP'] << 16) + 0x0140;
var snridMBTemperature2 =       (parent.asID['ASWM_SNRTYPE_TEMP'] << 16) + 0x0150;
var snridCPU1Temperature1 =    (parent.asID['ASWM_SNRTYPE_TEMP'] << 16) + 0x0200;
var snridCPU2Temperature1 =    (parent.asID['ASWM_SNRTYPE_TEMP'] << 16) + 0x0300;
var snridCPU1Temperature2 =    (parent.asID['ASWM_SNRTYPE_TEMP'] << 16) + 0x0210;
var snridCPU2Temperature2 =    (parent.asID['ASWM_SNRTYPE_TEMP'] << 16) + 0x0310;
var snridFBDCh0Slot0Temperature =   (parent.asID['ASWM_SNRTYPE_TEMP'] << 16) + 0x0400;
var snridFBDCh0Slot1Temperature =   (parent.asID['ASWM_SNRTYPE_TEMP'] << 16) + 0x0410;
var snridFBDCh1Slot0Temperature =   (parent.asID['ASWM_SNRTYPE_TEMP'] << 16) + 0x0440;
var snridFBDCh1Slot1Temperature =   (parent.asID['ASWM_SNRTYPE_TEMP'] << 16) + 0x0450;
var snridFBDCh2Slot0Temperature =   (parent.asID['ASWM_SNRTYPE_TEMP'] << 16) + 0x0480;
var snridFBDCh2Slot1Temperature =   (parent.asID['ASWM_SNRTYPE_TEMP'] << 16) + 0x0490;
var snridFBDCh3Slot0Temperature =   (parent.asID['ASWM_SNRTYPE_TEMP'] << 16) + 0x04C0;
var snridFBDCh3Slot1Temperature =   (parent.asID['ASWM_SNRTYPE_TEMP'] << 16) + 0x04D0;

var snridVcore1Voltage =       (parent.asID['ASWM_SNRTYPE_VOLTAGE'] << 16) + 0x0110;
var snridVcore2Voltage =       (parent.asID['ASWM_SNRTYPE_VOLTAGE'] << 16) + 0x0120;

var snridFan1Speed =           (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x0110;
var snridFan2Speed =           (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x0120;
var snridFan3Speed =           (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x0130;
var snridFan4Speed =           (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x0140;
var snridFan5Speed =           (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x0150;
var snridFan6Speed =           (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x0160;
var snridFan7Speed =           (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x0170;
var snridFan8Speed =           (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x0180;
var snridFan9Speed =           (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x0190;
var snridFan10Speed =          (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x01A0;

var snridBkplBay1Plug  =       (parent.asID['ASWM_SNRTYPE_PLUGINOUT'] << 16) + 0x1110;
var snridBkplBay2Plug  =       (parent.asID['ASWM_SNRTYPE_PLUGINOUT'] << 16) + 0x1120;
var snridBkplBay3Plug  =       (parent.asID['ASWM_SNRTYPE_PLUGINOUT'] << 16) + 0x1130;
var snridBkplBay4Plug  =       (parent.asID['ASWM_SNRTYPE_PLUGINOUT'] << 16) + 0x1140;

var compPower = new SysComponentInfo ('POWER', "parent.I18N['POWERMODULE']", 'info_power.jpg',
    new Tuple (
        new triple ("parent.I18N['POWERMODULE']", "1", snsridHasDMI),
        new triple ("parent.I18N['POWERMODULE']", "parent.once.findFRU(34, 2, 6)", snsridHasFRU)
    )
);
var compPCI = new SysComponentInfo ('PCI', "parent.I18N['EXPANDSLOTS']", 'info_pci.jpg',
    new Tuple (
        new triple ("parent.once.findDMI(parent.once.theDMISlotData, 1, 4).value", "parent.once.findDMI(parent.once.theDMISlotData, 1, 5).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 1, 6).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 1, 7).extra", snsridHasDMI),
        new triple ("parent.once.findDMI(parent.once.theDMISlotData, 2, 4).value", "parent.once.findDMI(parent.once.theDMISlotData, 2, 5).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 2, 6).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 2, 7).extra", snsridHasDMI)
    )
);

var compFan1 = new SysComponentInfo ('FAN1', "parent.once.GSensorNames[parent.once.snridFan1Speed]", 'info_fan_s.jpg',
    new Tuple (
        new triple ("parent.I18N['CURRSPEED']", "parent.once.GSensors.idAt(parent.once.snridFan1Speed).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFan1Speed).unit]", snridFan1Speed)
    )
);
var compFan2_3 = new SysComponentInfo ('FAN2_3', "parent.I18N['FANMODULE']", 'info_fan.jpg',
    new Tuple (
        new triple ("parent.once.GSensorNames[parent.once.snridFan2Speed]", "parent.once.GSensors.idAt(parent.once.snridFan2Speed).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFan2Speed).unit]", snridFan2Speed),
        new triple ("parent.once.GSensorNames[parent.once.snridFan3Speed]", "parent.once.GSensors.idAt(parent.once.snridFan3Speed).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFan3Speed).unit]", snridFan3Speed)
    )
);
var compFan4_5 = new SysComponentInfo ('FAN4_5', "parent.I18N['FANMODULE']", 'info_fan.jpg',
    new Tuple (
        new triple ("parent.once.GSensorNames[parent.once.snridFan4Speed]", "parent.once.GSensors.idAt(parent.once.snridFan4Speed).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFan4Speed).unit]", snridFan4Speed),
        new triple ("parent.once.GSensorNames[parent.once.snridFan5Speed]", "parent.once.GSensors.idAt(parent.once.snridFan5Speed).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFan5Speed).unit]", snridFan5Speed)
    )
);
var compFan6_7 = new SysComponentInfo ('FAN6_7', "parent.I18N['FANMODULE']", 'info_fan.jpg',
    new Tuple (
        new triple ("parent.once.GSensorNames[parent.once.snridFan6Speed]", "parent.once.GSensors.idAt(parent.once.snridFan6Speed).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFan6Speed).unit]", snridFan6Speed),
        new triple ("parent.once.GSensorNames[parent.once.snridFan7Speed]", "parent.once.GSensors.idAt(parent.once.snridFan7Speed).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFan7Speed).unit]", snridFan7Speed)
	)
);
var compFan8_9 = new SysComponentInfo ('FAN8_9', "parent.I18N['FANMODULE']", 'info_fan.jpg',
    new Tuple (
        new triple ("parent.once.GSensorNames[parent.once.snridFan8Speed]", "parent.once.GSensors.idAt(parent.once.snridFan8Speed).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFan8Speed).unit]", snridFan8Speed),
        new triple ("parent.once.GSensorNames[parent.once.snridFan9Speed]", "parent.once.GSensors.idAt(parent.once.snridFan9Speed).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFan9Speed).unit]", snridFan9Speed)
    )
);
var compFan10 = new SysComponentInfo ('FAN10', "parent.once.GSensorNames[parent.once.snridFan10Speed]", 'info_fan_s.jpg',
    new Tuple (
        new triple ("parent.I18N['CURRSPEED']", "parent.once.GSensors.idAt(parent.once.snridFan10Speed).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFan10Speed).unit]", snridFan10Speed)
    )
);

var compMotherboard = new SysComponentInfo ('MOTHERBOARD', "parent.I18N['MOTHERBOARD']", 'info_board.jpg',
    new Tuple (
        new triple ("parent.once.theSysInfo.quadrupleExtraAt(9)", "parent.once.theSysInfo.pairAt(9)"),
        new triple ("parent.once.GSensorNames[parent.once.snridMBTemperature1]", "parent.once.GSensors.idAt(parent.once.snridMBTemperature1).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridMBTemperature1).unit]", snridMBTemperature1),
        new triple ("parent.once.GSensorNames[parent.once.snridMBTemperature2]", "parent.once.GSensors.idAt(parent.once.snridMBTemperature2).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridMBTemperature2).unit]", snridMBTemperature2),
        new triple ("parent.once.GSensorNames[parent.once.snridCPU1Temperature1]", "parent.once.GSensors.idAt(parent.once.snridCPU1Temperature1).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridCPU1Temperature1).unit]", snridCPU1Temperature1),
        new triple ("parent.once.GSensorNames[parent.once.snridCPU1Temperature2]", "parent.once.GSensors.idAt(parent.once.snridCPU1Temperature2).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridCPU1Temperature2).unit]", snridCPU1Temperature2),
        new triple ("parent.once.GSensorNames[parent.once.snridCPU2Temperature1]", "parent.once.GSensors.idAt(parent.once.snridCPU2Temperature1).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridCPU2Temperature1).unit]", snridCPU2Temperature1),
        new triple ("parent.once.GSensorNames[parent.once.snridCPU2Temperature2]", "parent.once.GSensors.idAt(parent.once.snridCPU2Temperature2).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridCPU2Temperature2).unit]", snridCPU2Temperature2)
    )
);
var compMemory;
if (parent.once.hasNewSmBiosMemFeature) {
    compMemory = new SysComponentInfo ('DIMM', "parent.I18N['RAMMODULE']", 'info_ddr.jpg',
        new Tuple (
            new triple ("parent.I18N['MEMORYARRAY']", "parent.once.findDMI(parent.once.theDMIPhyscalMemArray, 1, 6).extra", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemDeviceData, 1, 11).value + '/' + parent.once.findDMI(parent.once.theDMIMemDeviceData, 1, 12).value",
                "parent.once.findDMI(parent.once.theDMIMemDeviceData, 1, 13).extra + '/' + parent.once.smbios_dimmsize2(parent.once.findDMI(parent.once.theDMIMemDeviceData, 1, 8).value) + " +
                "parent.once.dumpSnsrValue(parent.once.snridFBDCh0Slot0Temperature, 'TEMP', 'N/A')",
                "parent.once.getSnsrCurrStatus(parent.once.snsridHasDMI)|parent.once.getSnsrCurrStatus(parent.once.snridFBDCh0Slot0Temperature)"),
            new triple ("parent.once.findDMI(parent.once.theDMIMemDeviceData, 2, 11).value + '/' + parent.once.findDMI(parent.once.theDMIMemDeviceData, 2, 12).value",
                "parent.once.findDMI(parent.once.theDMIMemDeviceData, 2, 13).extra + '/' + parent.once.smbios_dimmsize2(parent.once.findDMI(parent.once.theDMIMemDeviceData, 2, 8).value) + " +
                "parent.once.dumpSnsrValue(parent.once.snridFBDCh0Slot1Temperature, 'TEMP', 'N/A')",
                "parent.once.getSnsrCurrStatus(parent.once.snsridHasDMI)|parent.once.getSnsrCurrStatus(parent.once.snridFBDCh0Slot1Temperature)"),
            new triple ("parent.once.findDMI(parent.once.theDMIMemDeviceData, 3, 11).value + '/' + parent.once.findDMI(parent.once.theDMIMemDeviceData, 3, 12).value",
                "parent.once.findDMI(parent.once.theDMIMemDeviceData, 3, 13).extra + '/' + parent.once.smbios_dimmsize2(parent.once.findDMI(parent.once.theDMIMemDeviceData, 3, 8).value) + " +
                "parent.once.dumpSnsrValue(parent.once.snridFBDCh1Slot0Temperature, 'TEMP', 'N/A')",
                "parent.once.getSnsrCurrStatus(parent.once.snsridHasDMI)|parent.once.getSnsrCurrStatus(parent.once.snridFBDCh1Slot0Temperature)"),
            new triple ("parent.once.findDMI(parent.once.theDMIMemDeviceData, 4, 11).value + '/' + parent.once.findDMI(parent.once.theDMIMemDeviceData, 4, 12).value",
                "parent.once.findDMI(parent.once.theDMIMemDeviceData, 4, 13).extra + '/' + parent.once.smbios_dimmsize2(parent.once.findDMI(parent.once.theDMIMemDeviceData, 4, 8).value) + " +
                "parent.once.dumpSnsrValue(parent.once.snridFBDCh1Slot1Temperature, 'TEMP', 'N/A')",
                "parent.once.getSnsrCurrStatus(parent.once.snsridHasDMI)|parent.once.getSnsrCurrStatus(parent.once.snridFBDCh1Slot1Temperature)"),
            new triple ("parent.once.findDMI(parent.once.theDMIMemDeviceData, 5, 11).value + '/' + parent.once.findDMI(parent.once.theDMIMemDeviceData, 5, 12).value",
                "parent.once.findDMI(parent.once.theDMIMemDeviceData, 5, 13).extra + '/' + parent.once.smbios_dimmsize2(parent.once.findDMI(parent.once.theDMIMemDeviceData, 5, 8).value) + " +
                "parent.once.dumpSnsrValue(parent.once.snridFBDCh2Slot0Temperature, 'TEMP', 'N/A')",
                "parent.once.getSnsrCurrStatus(parent.once.snsridHasDMI)|parent.once.getSnsrCurrStatus(parent.once.snridFBDCh2Slot0Temperature)"),
            new triple ("parent.once.findDMI(parent.once.theDMIMemDeviceData, 6, 11).value + '/' + parent.once.findDMI(parent.once.theDMIMemDeviceData, 6, 12).value",
                "parent.once.findDMI(parent.once.theDMIMemDeviceData, 6, 13).extra + '/' + parent.once.smbios_dimmsize2(parent.once.findDMI(parent.once.theDMIMemDeviceData, 6, 8).value) + " +
                "parent.once.dumpSnsrValue(parent.once.snridFBDCh2Slot1Temperature, 'TEMP', 'N/A')",
                "parent.once.getSnsrCurrStatus(parent.once.snsridHasDMI)|parent.once.getSnsrCurrStatus(parent.once.snridFBDCh2Slot1Temperature)"),
            new triple ("parent.once.findDMI(parent.once.theDMIMemDeviceData, 7, 11).value + '/' + parent.once.findDMI(parent.once.theDMIMemDeviceData, 7, 12).value",
                "parent.once.findDMI(parent.once.theDMIMemDeviceData, 7, 13).extra + '/' + parent.once.smbios_dimmsize2(parent.once.findDMI(parent.once.theDMIMemDeviceData, 7, 8).value) + " +
                "parent.once.dumpSnsrValue(parent.once.snridFBDCh3Slot0Temperature, 'TEMP', 'N/A')",
                "parent.once.getSnsrCurrStatus(parent.once.snsridHasDMI)|parent.once.getSnsrCurrStatus(parent.once.snridFBDCh3Slot0Temperature)"),
            new triple ("parent.once.findDMI(parent.once.theDMIMemDeviceData, 8, 11).value + '/' + parent.once.findDMI(parent.once.theDMIMemDeviceData, 8, 12).value",
                "parent.once.findDMI(parent.once.theDMIMemDeviceData, 8, 13).extra + '/' + parent.once.smbios_dimmsize2(parent.once.findDMI(parent.once.theDMIMemDeviceData, 8, 8).value) + " +
                "parent.once.dumpSnsrValue(parent.once.snridFBDCh3Slot1Temperature, 'TEMP', 'N/A')",
                "parent.once.getSnsrCurrStatus(parent.once.snsridHasDMI)|parent.once.getSnsrCurrStatus(parent.once.snridFBDCh3Slot1Temperature)")
        )
    );
} else {
    compMemory = new SysComponentInfo ('DIMM', "parent.I18N['RAMMODULE']", 'info_ddr.jpg',
        new Tuple (
            new triple ("parent.I18N['MEMORYCONTROLLER']", "parent.once.findDMI(parent.once.theDMIMemController, 1, 4).extra", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemModules, 1, 4).value", "parent.once.smbios_dimmsize(parent.once.findDMI(parent.once.theDMIMemModules, 1, 9).value)", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemModules, 2, 4).value", "parent.once.smbios_dimmsize(parent.once.findDMI(parent.once.theDMIMemModules, 2, 9).value)", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemModules, 3, 4).value", "parent.once.smbios_dimmsize(parent.once.findDMI(parent.once.theDMIMemModules, 3, 9).value)", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemModules, 4, 4).value", "parent.once.smbios_dimmsize(parent.once.findDMI(parent.once.theDMIMemModules, 4, 9).value)", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemModules, 5, 4).value", "parent.once.smbios_dimmsize(parent.once.findDMI(parent.once.theDMIMemModules, 5, 9).value)", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemModules, 6, 4).value", "parent.once.smbios_dimmsize(parent.once.findDMI(parent.once.theDMIMemModules, 6, 9).value)", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemModules, 7, 4).value", "parent.once.smbios_dimmsize(parent.once.findDMI(parent.once.theDMIMemModules, 7, 9).value)", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemModules, 8, 4).value", "parent.once.smbios_dimmsize(parent.once.findDMI(parent.once.theDMIMemModules, 8, 9).value)", snsridHasDMI),
            new triple ("parent.once.GSensorNames[parent.once.snridFBDCh0Slot0Temperature]",
                "parent.once.GSensors.idAt(parent.once.snridFBDCh0Slot0Temperature).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFBDCh0Slot0Temperature).unit]", snridFBDCh0Slot0Temperature),
            new triple ("parent.once.GSensorNames[parent.once.snridFBDCh0Slot1Temperature]",
                "parent.once.GSensors.idAt(parent.once.snridFBDCh0Slot1Temperature).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFBDCh0Slot1Temperature).unit]", snridFBDCh0Slot1Temperature),
            new triple ("parent.once.GSensorNames[parent.once.snridFBDCh1Slot0Temperature]",
                "parent.once.GSensors.idAt(parent.once.snridFBDCh1Slot0Temperature).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFBDCh1Slot0Temperature).unit]", snridFBDCh1Slot0Temperature),
            new triple ("parent.once.GSensorNames[parent.once.snridFBDCh1Slot1Temperature]",
                "parent.once.GSensors.idAt(parent.once.snridFBDCh1Slot1Temperature).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFBDCh1Slot1Temperature).unit]", snridFBDCh1Slot1Temperature),
            new triple ("parent.once.GSensorNames[parent.once.snridFBDCh2Slot0Temperature]",
                "parent.once.GSensors.idAt(parent.once.snridFBDCh2Slot0Temperature).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFBDCh2Slot0Temperature).unit]", snridFBDCh2Slot0Temperature),
            new triple ("parent.once.GSensorNames[parent.once.snridFBDCh2Slot1Temperature]",
                "parent.once.GSensors.idAt(parent.once.snridFBDCh2Slot1Temperature).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFBDCh2Slot1Temperature).unit]", snridFBDCh2Slot1Temperature),
            new triple ("parent.once.GSensorNames[parent.once.snridFBDCh3Slot0Temperature]",
                "parent.once.GSensors.idAt(parent.once.snridFBDCh3Slot0Temperature).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFBDCh3Slot0Temperature).unit]", snridFBDCh3Slot0Temperature),
            new triple ("parent.once.GSensorNames[parent.once.snridFBDCh3Slot1Temperature]",
                "parent.once.GSensors.idAt(parent.once.snridFBDCh3Slot1Temperature).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFBDCh3Slot1Temperature).unit]", snridFBDCh3Slot1Temperature)
        )
    );
}
var compCPU1 = new SysComponentInfo ('CPU1', "parent.I18N['CPU'] + ' 1'", 'info_cpu1.jpg',
    new Tuple (
        new triple ("parent.I18N['CPU']", "parent.once.findDMI(parent.once.theDMIProcessor, 1, 9).value + ' ' + parent.once.findDMI(parent.once.theDMIProcessor, 1, 13).value + 'Mhz'", snridVcore1Voltage),
        new triple ("parent.once.GSensorNames[parent.once.snridCPU1Temperature1]", "parent.once.GSensors.idAt(parent.once.snridCPU1Temperature1).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridCPU1Temperature1).unit]", snridCPU1Temperature1),
        new triple ("parent.once.GSensorNames[parent.once.snridCPU1Temperature2]", "parent.once.GSensors.idAt(parent.once.snridCPU1Temperature2).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridCPU1Temperature2).unit]", snridCPU1Temperature2),
        new triple ("parent.once.GSensorNames[parent.once.snridVcore1Voltage]", "parent.once.GSensors.idAt(parent.once.snridVcore1Voltage).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridVcore1Voltage).unit]", snridVcore1Voltage)
    )
);
var compCPU2 = new SysComponentInfo ('CPU2', "parent.I18N['CPU'] + ' 2'", 'info_cpu2.jpg',
    new Tuple (
        new triple ("parent.I18N['CPU']", "parent.once.findDMI(parent.once.theDMIProcessor, 2, 9).value + ' ' + parent.once.findDMI(parent.once.theDMIProcessor, 2, 13).value + 'Mhz'", snridVcore2Voltage),
        new triple ("parent.once.GSensorNames[parent.once.snridCPU2Temperature1]", "parent.once.GSensors.idAt(parent.once.snridCPU2Temperature1).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridCPU2Temperature1).unit]", snridCPU2Temperature1),
        new triple ("parent.once.GSensorNames[parent.once.snridCPU2Temperature2]", "parent.once.GSensors.idAt(parent.once.snridCPU2Temperature2).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridCPU2Temperature2).unit]", snridCPU2Temperature2),
        new triple ("parent.once.GSensorNames[parent.once.snridVcore2Voltage]", "parent.once.GSensors.idAt(parent.once.snridVcore2Voltage).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridVcore2Voltage).unit]", snridVcore2Voltage)
    )
);

var compBackplaneBoard = new SysComponentInfo ('BACKPLANEBOARD', "parent.I18N['BACKPLANE']", 'info_bp.jpg',
    new Tuple (
        new triple ("parent.I18N['BACKPLANE']", "parent.once.findFRU(17, 2, 6)", snsridHasFRU)
    )
);

var compBackplane = new SysComponentInfo ('BACKPLANE', "parent.I18N['BACKPLANE']",
    new SysCompositeImage (
        'IBACKPLANE', 
        new Tuple (
            '"<TABLE WIDTH=\\"270\\" height=\\"205\\" BGCOLOR=\\"#DBDBDB\\" BORDER=\\"0\\" CELLPADDING=\\"0\\" CELLSPACING=\\"0\\">"',
            '"<TR><TD colspan=\\"6\\" WIDTH=\\"270\\" height=\\"1\\"04><IMG SRC=\\"" + parent.once.imgPath + "hd_01.gif\\"></TD></TR>"',
            '"<TR><TD width=\\"23\\" height=\\"16\\"><IMG SRC=\\"" + parent.once.imgPath + "hd_02.gif\\"></TD>"',
            '"	<TD width=\\"56\\" height=\\"16\\"><IMG SRC=\\"" + parent.once.imgPath + (parent.once.GSensors.idAt(parent.once.snridBkplBay1Plug).currvalue == 1 ? "hd_ok" : "hd_no1") + ".gif\\"></TD>"',
            '"	<TD width=\\"56\\" height=\\"16\\"><IMG SRC=\\"" + parent.once.imgPath + (parent.once.GSensors.idAt(parent.once.snridBkplBay2Plug).currvalue == 1 ? "hd_ok" : "hd_no2") + ".gif\\"></TD>"',
            '"	<TD width=\\"56\\" height=\\"16\\"><IMG SRC=\\"" + parent.once.imgPath + (parent.once.GSensors.idAt(parent.once.snridBkplBay3Plug).currvalue == 1 ? "hd_ok" : "hd_no3") + ".gif\\"></TD>"',
            '"	<TD width=\\"56\\" height=\\"16\\"><IMG SRC=\\"" + parent.once.imgPath + (parent.once.GSensors.idAt(parent.once.snridBkplBay4Plug).currvalue == 1 ? "hd_ok" : "hd_no4") + ".gif\\"></TD>"',
            '"	<TD width=\\"23\\" height=\\"16\\"><IMG SRC=\\"" + parent.once.imgPath + "hd_03.gif\\"></TD></TR>"',
            '"<TR><TD colspan=\\"6\\" WIDTH=\\"270\\" height=\\"85\\"><IMG SRC=\\"" + parent.once.imgPath + "hd_04.gif\\"></TD></TR></TABLE>"'
        )
    ),
    new Tuple (
        new triple ("parent.I18N['BACKPLANE']", "parent.once.findFRU(17, 2, 6)", snsridHasFRU),
        new triple ("parent.I18N['HARDDISK_NUMBER']", 
            "parent.once.GSensors.idAt(parent.once.snridBkplBay1Plug).currvalue + " +
            "parent.once.GSensors.idAt(parent.once.snridBkplBay2Plug).currvalue + " +
            "parent.once.GSensors.idAt(parent.once.snridBkplBay3Plug).currvalue + " +
            "parent.once.GSensors.idAt(parent.once.snridBkplBay4Plug).currvalue",
            "parent.once.GSensors.idAt(parent.once.snridBkplBay1Plug).currstatus | parent.once.GSensors.idAt(parent.once.snridBkplBay2Plug).currstatus | parent.once.GSensors.idAt(parent.once.snridBkplBay3Plug).currstatus | parent.once.GSensors.idAt(parent.once.snridBkplBay4Plug).currstatus"
        )
    ),
    new Tuple (
        new triple ('IALARM_BACKPLANE_BAY1',
            new triple (new Point (-5, 105), '"<img src=\\"" + parent.once.imgPath + "hd_e1.gif\\">"', 3),
            new pair (parent.asID['IDV_TYPE_SNR'], snridBkplBay1Plug)
        ),
        new triple ('IALARM_BACKPLANE_BAY2',
            new triple (new Point (65, 105), '"<img src=\\"" + parent.once.imgPath + "hd_e2.gif\\">"', 5),
            new pair (parent.asID['IDV_TYPE_SNR'], snridBkplBay2Plug)
        ),
        new triple ('IALARM_BACKPLANE_BAY3',
            new triple (new Point (135, 105), '"<img src=\\"" + parent.once.imgPath + "hd_e3.gif\\">"', 5),
            new pair (parent.asID['IDV_TYPE_SNR'], snridBkplBay3Plug)
        ),
        new triple ('IALARM_BACKPLANE_BAY4',
            new triple (new Point (191, 105), '"<img src=\\"" + parent.once.imgPath + "hd_e4.gif\\">"', 3),
            new pair (parent.asID['IDV_TYPE_SNR'], snridBkplBay4Plug)
        )
    )
);
var compIOConnector = new SysComponentInfo ('IOCONNECTOR', "parent.I18N['IO_CONNECTOR']", 'info_port.jpg',
    new Tuple (
        new triple ("parent.I18N['PS2_PORT']", "2"),
        new triple ("parent.I18N['COM_PORT']", "1"),
        new triple ("parent.I18N['VGA_PORT']", "1"),
        new triple ("parent.I18N['LAN_PORT']", "2"),
        new triple ("parent.I18N['USB_PORT']", "2")
    )
);

var compRiser = new SysComponentInfo ('RISER', "parent.I18N['RISERBOARD']", 'info_riser.jpg',
    new Tuple (
        new triple ("parent.once.findDMI(parent.once.theDMISlotData, 1, 4).value", "parent.once.findDMI(parent.once.theDMISlotData, 1, 5).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 1, 6).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 1, 7).extra", snsridHasDMI),
        new triple ("parent.once.findDMI(parent.once.theDMISlotData, 2, 4).value", "parent.once.findDMI(parent.once.theDMISlotData, 2, 5).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 2, 6).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 2, 7).extra", snsridHasDMI)
    )
);

var compIPMI = new SysComponentInfo ('IPMI', "'IPMI'", 
    new SysCompositeImage (
        'IPMI',
        new Tuple (
            '"<img src=\\"" + parent.once.imgPath + (parent.once.findIPMI(parent.once.theASMAInfo, 16) ? "info_ipmi_2.jpg" : "info_ipmi.jpg") + "\\">"'
        )
    ),
    new Tuple (
        new triple ("parent.I18N['IPMI_CARDTYPE']", "parent.once.findIPMI(parent.once.theASMAInfo, 16)", snsridHasIPMI)
    )
);


var theSystemComponents = new Tuple (
    compBackplane,
    compBackplaneBoard,
    compIOConnector,
    compRiser,
    compPower,
    compFan1,
    compFan2_3,
    compFan4_5,
    compFan6_7,
    compFan8_9,
    compFan10,
    compMotherboard,
    compIPMI,
    compMemory,
    compPCI,
    compCPU1,
    compCPU2
);


//////////////////////////////////////////////
// The System with Views

var imgPath = './img/rs160-e4_pa4/';
var imgPanelFront = 'main_front.gif';
var imgPanelRear = 'main_rear.gif';
var imgPanelTop = 'main_top.gif';
var theSystem = new SysModel ('model.jpg', chassis_rackmount);

theSystem.attachView('h',
    new SysModelView (parent.I18N['HOME'], parent.I18N['HOME'])
);

theSystem.attachView('f',
    new SysModelView (parent.I18N['FRONT_VIEW'], parent.I18N['FRONT'],
        'view_front_o.jpg', 'view_front.jpg', 'info_front.jpg',
        new MapOfAreas (
            new AnArea (new Rect ( 13, 190, 278, 208), compBackplane)
        ),
        new Tuple (
            new quadruple ('AL_BACKPLANE', parent.asID['IDV_TYPE_SNRGROUP'], parent.asLbID['ASWM_SNRGROUP_BACKPLANE1'], new Point (136, 191))
        )
    )
);

theSystem.attachView('t',
    new SysModelView (parent.I18N['TOP_VIEW'], parent.I18N['TOP'],
        'view_top_o.jpg', 'view_top.jpg', 'info_top.jpg',
        new MapOfAreas (
            new AnArea (new Rect ( 65,  68,  77,  96), compIPMI),
            new AnArea (new Rect ( 28, 158, 187, 218), compBackplane),
            new AnArea (new Rect ( 30, 139, 185, 159), compBackplaneBoard),
            new AnArea (new Rect (143,   5, 184, 103), compPower),
            new AnArea (new Rect ( 33, 127,  48, 138), compFan1),
            new AnArea (new Rect ( 78, 120,  94, 139), compFan2_3),
            new AnArea (new Rect ( 93, 120, 110, 139), compFan4_5),
            new AnArea (new Rect (110, 120, 126, 139), compFan6_7),
            new AnArea (new Rect (126, 120, 142, 139), compFan8_9),
            new AnArea (new Rect (170, 127, 185, 138), compFan10),
            new AnArea (new Rect ( 63,  19,  75,  57), compRiser),
            new AnArea (new Rect (103,  17, 136,  65), compMemory),
            new AnArea (new Rect (105,  74, 132,  96), compCPU1),
            new AnArea (new Rect ( 77,  74, 104,  96), compCPU2),
            new AnArea (new Rect ( 29,   7, 144, 116), compMotherboard)
        ),
        new Tuple (
            new quadruple ('AL_FAN1', parent.asID['IDV_TYPE_SNR'],  snridFan1Speed, new Point (31, 124)),
            new quadruple ('AL_FAN2', parent.asID['IDV_TYPE_SNR'],  snridFan2Speed, new Point (77, 117)),
            new quadruple ('AL_FAN3', parent.asID['IDV_TYPE_SNR'],  snridFan3Speed, new Point (77, 125)),
            new quadruple ('AL_FAN4', parent.asID['IDV_TYPE_SNR'],  snridFan4Speed, new Point (92, 117)),
            new quadruple ('AL_FAN5', parent.asID['IDV_TYPE_SNR'],  snridFan5Speed, new Point (92, 125)),
            new quadruple ('AL_FAN6', parent.asID['IDV_TYPE_SNR'],  snridFan6Speed, new Point (109, 117)),
            new quadruple ('AL_FAN7', parent.asID['IDV_TYPE_SNR'],  snridFan7Speed, new Point (109, 125)),
            new quadruple ('AL_FAN8', parent.asID['IDV_TYPE_SNR'],  snridFan8Speed, new Point (125, 117)),
            new quadruple ('AL_FAN9', parent.asID['IDV_TYPE_SNR'],  snridFan9Speed, new Point (125, 125)),
            new quadruple ('AL_FANA', parent.asID['IDV_TYPE_SNR'], snridFan10Speed, new Point (168, 124)),
            new quadruple ('AL_FBDC0S0TEMP', parent.asID['IDV_TYPE_SNR'], snridFBDCh0Slot0Temperature, new Point (110, 33)),
            new quadruple ('AL_FBDC0S1TEMP', parent.asID['IDV_TYPE_SNR'], snridFBDCh0Slot1Temperature, new Point (110, 33)),
            new quadruple ('AL_FBDC1S0TEMP', parent.asID['IDV_TYPE_SNR'], snridFBDCh1Slot0Temperature, new Point (110, 33)),
            new quadruple ('AL_FBDC1S1TEMP', parent.asID['IDV_TYPE_SNR'], snridFBDCh1Slot1Temperature, new Point (110, 33)),
            new quadruple ('AL_FBDC2S0TEMP', parent.asID['IDV_TYPE_SNR'], snridFBDCh2Slot0Temperature, new Point (110, 33)),
            new quadruple ('AL_FBDC2S1TEMP', parent.asID['IDV_TYPE_SNR'], snridFBDCh2Slot1Temperature, new Point (110, 33)),
            new quadruple ('AL_FBDC3S0TEMP', parent.asID['IDV_TYPE_SNR'], snridFBDCh3Slot0Temperature, new Point (110, 33)),
            new quadruple ('AL_FBDC3S1TEMP', parent.asID['IDV_TYPE_SNR'], snridFBDCh3Slot1Temperature, new Point (110, 33)),
            new quadruple ('AL_CPU1TEMP1', parent.asID['IDV_TYPE_SNR'], snridCPU1Temperature1, new Point (109, 77)),
            new quadruple ('AL_CPU1TEMP2', parent.asID['IDV_TYPE_SNR'], snridCPU1Temperature2, new Point (109, 77)),
            new quadruple ('AL_CPU2TEMP1', parent.asID['IDV_TYPE_SNR'], snridCPU2Temperature1, new Point (81, 77)),
            new quadruple ('AL_CPU2TEMP2', parent.asID['IDV_TYPE_SNR'], snridCPU2Temperature2, new Point (81, 77)),
            new quadruple ('AL_VCORE1', parent.asID['IDV_TYPE_SNR'], snridVcore1Voltage, new Point (109, 77)),
            new quadruple ('AL_VCORE2', parent.asID['IDV_TYPE_SNR'], snridVcore2Voltage, new Point (81, 77)),
            new quadruple ('AL_MBTEMP1', parent.asID['IDV_TYPE_SNR'], snridMBTemperature1, new Point (77, 53)),
            new quadruple ('AL_MBTEMP2', parent.asID['IDV_TYPE_SNR'], snridMBTemperature2, new Point (77, 53)),
            new quadruple ('AL_BACKPLANE', parent.asID['IDV_TYPE_SNRGROUP'], parent.asLbID['ASWM_SNRGROUP_BACKPLANE1'], new Point (98, 180))
        )
    )
);

theSystem.attachView('r',
    new SysModelView (parent.I18N['REAR_VIEW'], parent.I18N['REAR'],
        'view_rear_o.jpg', 'view_rear.jpg', 'info_rear.jpg',
        new MapOfAreas (
            new AnArea (new Rect ( 13, 186,  84, 211), compPower),
            new AnArea (new Rect ( 85, 189, 177, 211), compIOConnector),
            new AnArea (new Rect (127, 188, 261, 199), compRiser)
        )
    )
);


//////////////////////////////////////////////
// The System View Addon Item except default Item

var theSysViewInfoAddon = new Tuple (
    new GSysViewHealth ('h',
        "parent.I18N['BACKPLANE']", "(parent.once.theFRUInfo ? parent.once.findFRU(17, 2, 6) : '')"
    ),

    new GSysViewHealth ('f',
        "parent.I18N['BACKPLANE']", "(parent.once.theFRUInfo ? parent.once.findFRU(17, 2, 6) : '')",
        "parent.I18N['BACKPLANE_NUMBER']", "1",
        "parent.I18N['USB_PORT']", "2"
    ),
    new GSysViewHealth ('r',
        "parent.I18N['PS2_PORT']", "2",
        "parent.I18N['COM_PORT']", "1",
        "parent.I18N['VGA_PORT']", "1",
        "parent.I18N['LAN_PORT']", "2",
        "parent.I18N['USB_PORT']", "2",
        "parent.I18N['POWERMODULE']", "1"
    )
);


//////////////////////////////////////////////
// The System Backplane structure

var theSysBackplane = new Array ();

theSysBackplane[parent.asLbID['ASWM_SNRGROUP_BACKPLANE1']] = new SysBackplane (
    'BP4LSA-F10-R10', 'h_bp.jpg', compBackplane,
    new Tuple,
    new Tuple (
        new Tuple (snridBkplBay1Plug),
        new Tuple (snridBkplBay2Plug),
        new Tuple (snridBkplBay3Plug),
        new Tuple (snridBkplBay4Plug)
    ),
    new triple (parent.asID['ASWM_CFGGROUP_ASMA'] << 16, parent.asID['ASWM_SNRGROUP_BACKPLANE1'] << 16, parent.asID['ASWM_CFGTYPE_BACKPLANE'])
);
